** This file is part of aITALC
** Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
**-----------------------------------------------------------------------
** This subprogram needs the global variable input
** "maxexternalfermionindex" = # of external fermion lines

** and it exports the local variables
** "fermionloop" = # of fermion loops in the graph
** "cfactor" = multiplicative color factor of the internal loops = 3^{0,1,2,...}

** Should be included on the \Begin(initialization) part of the create file in Diana
** based on the comments of M.Tentyukov
*********************************************************************************

** Adding the variable fermionloop
\let(fermionloop,\sub(\maxfcount(),\import(maxexternalfermionindex)))

** Extracting the internal color of the loop
\let(cfactor,1)
\Begin(foreach,i,1,\numberofinternallines())
** You can't use \i() inside \if, so do as follows:
   \let(_lc,\linefcount(\i()))
   \let(_t,\linetype(\i()))
** loop? - assume here, we have exactly maxexternalfermionindex external ferm. lines:
   \if "\numcmp(\get(_lc),\import(maxexternalfermionindex))" eq ">" then
** Not taken into account yet?:
      \if "\exist(_tmp\get(_lc))" eq "false"  then
** Quark?:
         \if "\pos(\get(_t),\import(quarks))" ne "-1" then
** Increment color factor:
            \let(cfactor,\mul(3,\get(cfactor)))
** Take line into account:
            \let(_tmp\get(_lc),)
         \endif
      \endif
   \endif
\End(foreach)

** Killing those temporal variables used in fermion loop identification
\let(_el,\sum(\import(maxexternalfermionindex),1))
\Begin(foreach,i,\get(_el),\maxfcount())
    \killvar(_tmp\i())
\End(foreach)
\killvar(_el)

** $Id: fermionloopanalysis.prg,v 1.5 2004/10/20 14:11:29 alorca Exp $
