 * This file is part of aITALC
 * Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
 *-----------------------------------------------------------------------
** This subprogram exports the global variables

** "maxexternalfermionindex" = # of external fermion lines
** "linecolor(indexofexternalleg)" = 1/3 (leptons/quarks)
** "fflowout(indexofexternalleg)" = YES/NO (outgoing/ingoing)
** "fermioncode(indexofexternalleg)" = +1/-1 (particle/antiparticle)

** Should be included on the \Begin(initialization) part of the create file in
** Diana
** Created, 07/10/03
*********************************************************************************


** To get the number of fermion currents on external lines
\export(maxexternalfermionindex,0)
\Begin(foreach,e,1,\numberofexternallines())
     \let(_lc,\linefcount(-\e()))
     \let(_linecolor,1)
     \let(_t,\linetype(-\e()))
     \if "\numcmp(\get(_lc),\import(maxexternalfermionindex))" eq ">" then
        \export(maxexternalfermionindex,\get(_lc))
     \endif
     \if "\pos(\get(_t),\import(quarks))" ne "-1" then
       \let(_linecolor,3)
     \endif
     \export(linecolor(\e()),\get(_linecolor))
** And add the code particle (+1) or antiparticle (-1)
** \particle shows 'Le' or 'le'
** \beginpropagator shows always 'le' as defined in model
     \let(_pe,\particle(-\e()))
     \let(_bpe,\beginpropagator(-\e()))
     \if "\get(_pe)" eq "\get(_bpe)" then
	\let(_fermioncode,+1)
     \else
        \let(_fermioncode,-1)
     \endif

** _going contains (+1,-1) if (in,out)going
     \let(_going,\isingoing(\e())1)
     \if "\get(_fermioncode)" ne "\get(_going)" then
** We consider it as an appropriate right(adjoint) accompanier spinor in
** gammas chains in the ME definition
       \export(fflowout(\e()),YES)
     \else
       \export(fflowout(\e()),NO)
     \endif


\export(fermioncode(\e()),\get(_fermioncode))
\End(foreach)

\killvar(_linecolor)
\killvar(_fermioncode)
\killvar(_going)
** $Id: getextfermioncurrents.prg,v 1.4 2004/10/08 13:08:30 alorca Exp $
