 * This file is part of aITALC
 * Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
 *-----------------------------------------------------------------------
\Begin(tmlprogram,folders.tml)
\\@
\Begin(program,routines.rtn)
\section(common,browser,regular)
*-----------------------------------------------------------------
\Begin(initialization)
  *This initialization is necessary for \sift() and \headstr(): 
  \setcheck(0123456789)

*-----------------------------------------------------------------
* To have very nice postscripts with particle symbols
\include(particleaspect.prg)
*-----------------------------------------------------------------
  \IFSET(MakeInfo)
     \initInfoPS(@GET(_processname)Info.ps)
  \ENDIF
  \IFSET(MakePs)
     \initPostscript(
*namefile.ps,sizepage,orientation,hor-margin,vert-margin,book-margin,#columns,#rows,font,fontsize
                         @GET(_processname).ps,
                         A4,
                         Portrait,
                         20,
                         20,
                         00,
                         4,
                         10,
                         Helvetica,
                         20
                    )
   \ENDIF
*-----------------------------------------------------------------
** Specifying which prototypes are quarks
\export(quarks,ud)

* We get information about external fermion currents
\include(getextfermioncurrents.prg)

*-----------------------------------------------------------------

\End(initialization)


* CONTENT FOR FORM INPUT FILE
*=================================================================
* this makes one form file for all topologies:
*-----------------------------------------------------------------
\section(regular)

*-------------- START TOPOLOGIES CLUSTERING COLLECTION
\if not exist "first\topologyid()" then
   \if exist "topnames" then
       \export(topnames,\import(topnames)\(,)\replace(_,,\topologyid()))
   \else
       \export(topnames,\replace(_,,\topologyid()))
   \endif
   \export(first\topologyid(),\counter())
\endif
\export(last\topologyid(),\counter())
*-------------- END TOPOLOGIES CLUSTERING COLLECTION


*-------------- START FERMION LOOP ANALYSIS
\include(fermionloopanalysis.prg)
*-------------- END FERMION LOOP ANALYSIS

*-------------- START FERMION CURRENT ANALYSIS
\include(fermioncurrentanalysis.prg)
*-------------- END FERMION CURRENT ANALYSIS


\Begin(output,@GET(_processname).in)
  \IFSET(MakeInfoEps)
    \outInfoEPS(InfoEPS/i@GET(_processname)\currentdiagramnumber().eps,400,Helvetica,15)
  \ENDIF
  \IFSET(MakeEps)
    \outEPS(EPS/@GET(_processname)\currentdiagramnumber().eps,400,Helvetica,20)
  \ENDIF
   **** (diagram \currentdiagramnumber())

*-------------- START _looplevel definition
\if not exist "thefirst" then
\-
\let(_looplevel, \sub( \sum(\numberofinternallines(),1) ,\numberofvertex()) )
\if "\numcmp(\get(_looplevel),0)" eq "=" then
  \export(levelname,tree)
\elif "\numcmp(\get(_looplevel),1)" eq "=" then
  \export(levelname,loop)
\elif "\numcmp(\get(_looplevel),2)" eq "=" then
  \export(levelname,twoloops)
\else
  \export(levelname,higher)
\endif
\killvar(_looplevel)
\+
\endif
*-------------- END _looplevel definition

*-------------- START MATRIX ELEMENTS MOMENTA DEFINITION
\include(memomentadefinition.prg)
*-------------- END MATRIX ELEMENTS MOMENTA DEFINITION

*--------------
\include(analyze_looptype.prg)
*--------------


   \blankline()
*This is the same that (foreach,i,1,\numberofinternallines()) but with new relabeling of propagators
     \Begin(LINEMARKS,l,m)
        #define imm\m() "\mass(\l())"
        #define q\m() "\momentum(\l(),)"
        \-
	  \let(_l,\l())
	  \let(_m,\m())
        \+
	\if "\exist(_loopline\get(_l))" eq "true" then
          #define loopline\get(_m) "\get(_loopline\get(_l))"
        \endif
**	This is a m=\m() and this is a l=\l() and this is ilabel\l()=\get(_ilabel\m())

     \End(LINEMARKS)
   \blankline()
     \outputDummyMomenta(NM)
         #ifndef `k1'
     \Begin(foreach,i,1,\sub(\import(looptypenumber),1))
          #define k\i() "-`pc\sum(\sub(\numberofinternallines(),\import(looptypenumber)),\i())'"
     \End(foreach)
         #endif

*    \Begin(DUMMYMOMENTA)
*    \End(DUMMYMOMENTA)
   \blankline()
     #define DIAGRAM "\currentdiagramnumber()"
     #define COUNTER "\counter()"
     #define LINE "\numberofinternallines()"
     #define FERMIONLOOP "\get(fermionloop)"
     \if "\numcmp(\get(fermionloop),0)" eq ">" then
     #define COLORFACTOR "\get(cfactor)"
     \endif
     #define TOPOLOGY "\topologyid()"
     #define CHANNEL "\copy(\topologyid(),1,1)"
     #define SKELETON "\copy(\sift(\topologyid()),1,2)"
     #define LOOPTYPE "\import(looptype)"
     #define LOOPTYPENUMBER "\import(looptypenumber)"
**     #define LOOPTYPE "\replace(\sift(\copy(\topologyid(),2,4)),\(),\copy(\topologyid(),2,4))"
     #define PROTOTYPE "\prototype()"
     #define FERMIONCHANNEL "\import(fermionchannel)"
   \Begin(foreach,e,1,\numberofexternallines())
     #define l\e() "\linefcount(-\e())"
   \End(foreach)

   \blankline()
   *----------------------------------------- 
   g [Amplitude,\counter()] =\integrand();
   \offblanklines\offleadingspaces
   \blankline()
*-------------- To load external masses
  \if not exist "thefirst" then
   \offleadingspaces
   \breakfolder(exts)
     \blankline()
      #define LEVEL "\import(levelname)"
      #define LEGS "\numberofexternallines()"
      #define EXTFERMICURRENTS "\import(maxexternalfermionindex)"
      \blankline()
   \Begin(foreach,e,1,\numberofexternallines())
*Now we define many external properties, like:
* Mass squared, mass, abs(momenta), particle/antiparticle (+1/-1), and fermionline index.
      #define emm\e() "\mass(-\e())"
      #define em\e() "\replace(MM,M,\mass(-\e()))"
      #define absep\e() "\replace(-,+,\momentum(-\e(),))"
      #define eq\e() "\replace(MM,\replace(1,Q,\import(fermioncode(\e()))),\mass(-\e()))"
      #define color\e() "\import(linecolor(\e()))"
*      #define ep\e() "\momentum(-\e(),)"
      #define u\e() "\import(fermioncode(\e()))"
   \End(foreach)
      \blankline()
   \blank(\export(thefirst,))
 \endif
*--------------
\End(output)
*-----------------------------------------------------------------
\section(epilog)
\Begin(browser,not)
   \Begin(output)
      \blankline()
      #define NMAX "\counter()"
      \blankline()
*-------------- START TOPOLOGIES CLUSTERING OUTPUT
      \breakfolder(topologies)
      \blankline()
      #define topologiesnames "\import(topnames)"
      \blankline()
      \-\let(i,0)
      \while "\numcmp(\inc(i,1),\numberoftopologies())" ne ">" do
        \setcurrenttopology(\get(i))
        \if "\istopologyoccur()" eq "yes" then\+
          #$first\replace(_,,\topologyid()) =\import(first\topologyid());
          #$last\replace(_,,\topologyid()) =\import(last\topologyid());
          \blankline()
        \endif\-
      \loop\+
      #define fermioncurrentsnames "\import(fermiontopnames)"
      \blankline()
      \-
      \let(_ifermitop,-2)
      \label(nextfermitop)
      \let(_myfermitop,\copy(\import(fermiontopnames),\inc(_ifermitop,2),1))
      \while "\get(_myfermitop)" ne "" do
        \let(_iline,0)
        \while "\numcmp(\inc(_iline,1),\import(maxexternalfermionindex))" ne ">" do
          \+
          #define P\get(_myfermitop)\get(_iline) "\import(memomenta\get(_myfermitop)\get(_iline))"
          #define PAWAY\get(_myfermitop)\get(_iline) "\import(memomentaaway\get(_myfermitop)\get(_iline))"
          #define IFFO\get(_myfermitop)\get(_iline) "\import(ifflowout\get(_myfermitop)\get(_iline))" 
          #define IFFI\get(_myfermitop)\get(_iline) "\import(ifflowin\get(_myfermitop)\get(_iline))"
          \-
        \loop
        \goto(nextfermitop)
      \loop
      \killvar(i)\killvar(_myfermitop)\killvar(_ifermitop)\+
      \blankline()
*-------------- END TOPOLOGIES CLUSTERING OUTPUT
   \End(output)
\End(browser)
*-----------------------------------------------------------------
\End(program)
@@\
\End(tmlprogram)

** $Id: thetmlstuff.prg,v 1.8 2004/10/29 14:07:52 alorca Exp $
