# fortran/bin/ics_script.sh
# This file is part of aITALC
# Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>

#!/bin/bash

filename="$1"
outfilename="$1.eps"
labelprocess="$2"

echo "\
set output \"$outfilename\"
#set terminal postscript eps enhanced color solid 20
set terminal postscript eps enhanced monochrome 20
set size 0.75,1;
#set size square;
set title '{/Times-Roman=26 Integrated Cross Section}'
set ylabel '{/Times-Roman=24 {/Symbol s} (pb)}'
set xlabel '{/Times-Roman=24 {/Symbol \326}s (GeV)}'
set label \'$2\'
set logscale y
#set yrange [-5e-3:0]
#set xrange [88:95]
#set logscale x
set mytics 10
#set mxtics 5
set format y \"%.0e\"
show mytics
set linestyle 1 lt 1 lw 4 pt 1 ps 1
set linestyle 2 lt 2 lw 2 pt 1 ps 1
set linestyle 3 lt 3 lw 2 pt 1 ps 1
set linestyle 4 lt 4 lw 2 pt 1 ps 1
set linestyle 5 lt 5 lw 2 pt 1 ps 1
plot    \"$filename\" using 1:3 t \"Born\" with lines 1,\\
        \"$filename\" using 1:6 t \"B+corr\" with lines 4,\\
        \"$filename\" using 1:7 t \"loop^2\" with lines 5
exit
"\
 | gnuplot - 1>/dev/null

#$Id: ics_script.sh,v 1.2 2004/10/07 15:05:08 alorca Exp $
